// scancrdsDlg.cpp : implementation file
//
#include "stdafx.h"
#include "scancrds.h"
#include "scancrdsDlg.h"

#pragma comment(lib,"visa32.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CScancrdsDlg dialog

CScancrdsDlg::CScancrdsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScancrdsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScancrdsDlg)
	m_scrd1 = _T("");
	m_scrd2 = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CScancrdsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScancrdsDlg)
	DDX_Text(pDX, IDC_SCRD1, m_scrd1);
	DDX_Text(pDX, IDC_SCRD2, m_scrd2);
	DDX_Control(pDX, IDC_MSFLEXGRID1, m_grid1);
	DDX_Control(pDX, IDC_MSFLEXGRID2, m_grid2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CScancrdsDlg, CDialog)
	//{{AFX_MSG_MAP(CScancrdsDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTNQUIT, OnButnquit)
	ON_BN_CLICKED(IDC_BUTNEXE, OnButnexe)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScancrdsDlg message handlers

BOOL CScancrdsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	CString str;

	ViStatus   status;				// For checking errors 
	ViUInt32   retCount;			// Return count from string I/O 
	char       dev_instr[256];
	char       *wkbuf;
	unsigned long  findList = 0;

	dev_cnt = 0;
	status = viOpenDefaultRM(&defaultRM);
	if (status < VI_SUCCESS) /* Error Initializing VISA...exiting */
	{
		MessageBox("Open resource manager failed.", "scancrds", MB_OK);
		return TRUE;
	}
	// Find the USBTMC DMM devices  VID:0x164E  PID:0x0DAD
	status = viFindRsrc(defaultRM, "USB[0-9]*::0x164E::0x0DAD::?*INSTR", &findList, &dev_cnt, dev_instr);
	if (status < 0L) 
	{
		viClose(defaultRM);
		MessageBox("The DMM device(s) not found.", "scancrds", MB_OK);
		return TRUE;
	}

	instr1 = 0;
	instr2 = 0;
	scard[0] = 0;
	scard[1] = 0;
	if ( dev_cnt > 0 )
	{
		status = viOpen(defaultRM, dev_instr, VI_NULL, VI_NULL, &instr1);
		/* Set the timeout for message-based communication */
		status = viSetAttribute(instr1, VI_ATTR_TMO_VALUE, 5000);
		/* Allocate space for a path name */
		wkbuf = (char *)malloc( 13 );
		if( !wkbuf )
		{
			MessageBox("Insufficient memory available (viWrite).", "scancrds", MB_OK);
			return TRUE;
		}
		// Reset the device //
		strcpy(wkbuf, "*RST\n");
		status = viWrite(instr1, (unsigned char *)wkbuf, 5, &retCount);
		strcpy(wkbuf, "*CLS\n");
		status = viWrite(instr1, (unsigned char *)wkbuf, 5, &retCount);
		// Check the Scanner card configure for M3500A each
		strcpy(wkbuf, "Rout:state?\n");
		status = viWrite(instr1, (unsigned char *)wkbuf, 12, &retCount);
		Sleep(50);			
		free(wkbuf);
		wkbuf = (char *)malloc( 64 );
		if( !wkbuf )
		{
			MessageBox("Insufficient memory available (viRead).", "Sample_VC_1", MB_OK);
			return TRUE;
		}
		Sleep(30);
		status = viRead(instr1, (unsigned char *)wkbuf, 64, &retCount);
		if ( wkbuf[0] == '1' )
		{
			scard[0] = 1;
			GetDlgItem(IDC_MSFLEXGRID1)->EnableWindow(TRUE);
		}
		free(wkbuf);
		// find next desriptor 
		status = viFindNext(findList, dev_instr);  
		if (status >= 0L) 
		{   
			status = viOpen(defaultRM, dev_instr, VI_NULL, VI_NULL, &instr2);
			/* Set the timeout for message-based communication */
			status = viSetAttribute(instr2, VI_ATTR_TMO_VALUE, 5000);
			/* Allocate space for a path name */
			wkbuf = (char *)malloc( 13 );
			if( !wkbuf )
			{
				MessageBox("Insufficient memory available (viWrite).", "scancrds", MB_OK);
				return TRUE;
			}
			// Reset the device //
			strcpy(wkbuf, "*RST\n");
			status = viWrite(instr2, (unsigned char *)wkbuf, 5, &retCount);
			strcpy(wkbuf, "*CLS\n");
			status = viWrite(instr2, (unsigned char *)wkbuf, 5, &retCount);
			// Check the Scanner card configure for M3500A each
			strcpy(wkbuf, "Rout:state?\n");
			status = viWrite(instr2, (unsigned char *)wkbuf, 12, &retCount);
			Sleep(50);			
			free(wkbuf);
			wkbuf = (char *)malloc( 64 );
			if( !wkbuf )
			{
				MessageBox("Insufficient memory available (viRead).", "Sample_VC_1", MB_OK);
				return TRUE;
			}
			Sleep(30);
			status = viRead(instr2, (unsigned char *)wkbuf, 64, &retCount);
			if ( wkbuf[0] == '1' )
			{
				scard[1] = 1;
				GetDlgItem(IDC_MSFLEXGRID2)->EnableWindow(TRUE);
			}
		}
	}
	else
	{
		GetDlgItem(IDC_SCRD1)->EnableWindow(FALSE);
		GetDlgItem(IDC_SCRD2)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTNEXE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTNQUIT)->EnableWindow(TRUE);
		UpdateData(FALSE);
		MessageBox("Multimeter device(s) not found.", "Scanner card reading", MB_OK);
	}	

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CScancrdsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CScancrdsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CScancrdsDlg::OnButnquit() 
{
	// TODO: Add your control notification handler code here
	ViStatus   status;

	// Check all connected M3500A and release M3500A object 
	if ( scard[0] )
	{
		status = viClose(instr1);
	}
	if ( scard[1] )
	{
		status = viClose(instr2);
	}
	status = viClose(defaultRM);

	OnOK();
}

void CScancrdsDlg::OnButnexe() 
{
	// TODO: Add your control notification handler code here
	ViStatus   status;				// For checking errors
	ViUInt32   retCount;			// Return count from string I/O
	char    *wkbuf;
	char    *wkinbuf;
	int     i, j, m;
	int		pos, row;
	BOOL    fDone = FALSE; 
	MSG     msg;	
	CString str1;
	CString str2;

	if ( scard[0] )
	{
		/* Allocate space for a path name */
		wkbuf = (char *)malloc( 25 );
		if( !wkbuf )
		{
			MessageBox("Insufficient memory available (viWrite).", "scancrds", MB_OK);
			return;
		}
		// Set the configure //
		strcpy(wkbuf, "CONF:FRES 100000\n");
		status = viWrite(instr1, (unsigned char *)wkbuf, 17, &retCount);
		Sleep(50);
		// Assign the scan count = 20 //
		strcpy(wkbuf, "Rout:scan:count 20\n");
		status = viWrite(instr1, (unsigned char *)wkbuf, 19, &retCount);
		Sleep(50);
		// Assign the scanner card timer
		strcpy(wkbuf, "Rout:scan:timer 0.5\n");
		status = viWrite(instr1, (unsigned char *)wkbuf, 20, &retCount);
		Sleep(50);	

		// Set the Scanner card the channels scan function
		for (j=1; j<=5; j++)
		{
			str1.Format("%s%d,\"%s\"", "rout:scan:func ", j, "FRES");
			ZeroMemory(wkbuf, 25);
			for (i=0; i<str1.GetLength(); i++)
				wkbuf[i] = str1.GetAt(i);
			status = viWrite(instr1, (unsigned char *)wkbuf, str1.GetLength(), &retCount);
			Sleep(50);			
		}
		// Trig the scan operation //
		strcpy(wkbuf, "route:scan\n");
		status = viWrite(instr1, (unsigned char *)wkbuf, 11, &retCount);		
		free(wkbuf);
	}

	if ( scard[1] )
	{
		/* Allocate space for a path name */
		wkbuf = (char *)malloc( 25 );
		if( !wkbuf )
		{
			MessageBox("Insufficient memory available (viWrite).", "scancrds", MB_OK);
			return;
		}
		// Set the configure //
		strcpy(wkbuf, "CONF:FRES 100000\n");
		status = viWrite(instr2, (unsigned char *)wkbuf, 17, &retCount);
		Sleep(50);
		// Assign the scan count = 20 //
		strcpy(wkbuf, "Rout:scan:count 20\n");
		status = viWrite(instr2, (unsigned char *)wkbuf, 19, &retCount);
		Sleep(50);
		// Assign the scanner card timer
		strcpy(wkbuf, "Rout:scan:timer 0.5\n");
		status = viWrite(instr2, (unsigned char *)wkbuf, 20, &retCount);
		Sleep(50);	

		// Set the Scanner card the channels scan function
		for (j=1; j<=5; j++)
		{
			str1.Format("%s%d,\"%s\"", "rout:scan:func ", j, "FRES");
			ZeroMemory(wkbuf, 25);
			for (i=0; i<str1.GetLength(); i++)
				wkbuf[i] = str1.GetAt(i);
			status = viWrite(instr2, (unsigned char *)wkbuf, str1.GetLength(), &retCount);
			Sleep(50);			
		}
		// Trig the scan operation //
		strcpy(wkbuf, "route:scan\n");
		status = viWrite(instr2, (unsigned char *)wkbuf, 11, &retCount);		
		free(wkbuf);
	}

	if ( scard[0] )
		i = 1;
	else
		i = 0;
	if ( scard[1] )
		j = 1;
	else
		j = 0;

	wkbuf = (char *)malloc( 20 );
	if( !wkbuf )
	{
		MessageBox("Insufficient memory available.", "scancrds", MB_OK);
		return;
	}
	strcpy(wkbuf, "Rout:scan:state?\n");
	wkinbuf = (char *)malloc( 64 );
	if( !wkinbuf )
	{
		MessageBox("Insufficient memory available.", "scancrds", MB_OK);
		return;
	}
    while ( i || j )
	{
		while(true)
		{
			if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) 
			{
				if(msg.message != WM_QUIT)
				{
					TranslateMessage(&msg); 
					DispatchMessage(&msg); 
				}
			}
			else
				break;
		}
		// Check the scan reading state for M3500A device-0
		// and show the scanned count
		if ( i == 1 )
		{
			status = viWrite(instr1, (unsigned char *)wkbuf, 17, &retCount);
			Sleep(100);
			ZeroMemory(wkinbuf, 64);
			status = viRead(instr1, (unsigned char *)wkinbuf, 64, &retCount);
			m = int(atof(wkinbuf));
			str2.Format("%d / %s", m, "20");
			m_scrd1 = str2;
			UpdateData(FALSE);
			if( m >= 20)
				i = 0;
		}
		// Check the scan reading state for M3500A device-1
		// and show the scanned count
		if ( j == 1 )
		{
			status = viWrite(instr2, (unsigned char *)wkbuf, 17, &retCount);
			Sleep(100);
			ZeroMemory(wkinbuf, 64);
			status = viRead(instr2, (unsigned char *)wkinbuf, 64, &retCount);
			m = int(atof(wkinbuf));
			str2.Format("%d / %s", m, "20");
			m_scrd2 = str2;
			UpdateData(FALSE);
			if( m >= 20)
				j = 0;
		}
		Sleep(500);
	}
	free(wkbuf);
	free(wkinbuf);
	if ( scard[0] )
	{
		pos = 1;
		row = 1;
		m_grid1.SetRow(0);
		m_grid1.SetColWidth(0,600);

		// Show the Channels title on the Grid
		for(int i = 0 ; i < 5 ; i ++)
		{
			m_grid1.SetCol(i+1);
			m_grid1.SetColWidth(i+1,1500);
			str1.Format("CH%d(%s)", i+1, "4WR");
			m_grid1.SetCellAlignment(4);
			m_grid1.SetText(str1);
		}

		// Fetch the scanned readings
		wkbuf = (char *)malloc( 20 );
		if( !wkbuf )
		{
			MessageBox("Insufficient memory available.", "scancrds", MB_OK);
			return;
		}
		wkinbuf = (char *)malloc( 321 );
		if( !wkinbuf )
		{
			MessageBox("Insufficient memory available.", "scancrds", MB_OK);
			return;
		}
		strcpy(wkbuf, "fetch?\n");
		status = viWrite(instr1, (unsigned char *)wkbuf, 7, &retCount);
		Sleep(200);
		ZeroMemory(wkinbuf, 320);
		status = viRead(instr1, (unsigned char *)wkinbuf, 320, &retCount);
		str1.Format("%s,",wkinbuf);

		// Show the readings on the Grid
		while(pos > 0)
		{
			m_grid1.SetRow(row);
			m_grid1.SetCol(0);
			str2.Format("%d",row);
			m_grid1.SetText(str2);
			for(i = 0 ; i < 5; i ++)
			{	
				pos = str1.Find(",",0);
				if(pos < 1) 
					break;
				if(str1.Left(pos) == "+9.90000000E+37" || str1.Left(pos) == "+9.9E37\n")
					str2 = "OVLD";
				else
					str2.Format("%.6f",atof(str1.Left(pos)));
				m_grid1.SetCol(i+1);
				m_grid1.SetText(str2);
				str1 = str1.Mid(pos+1);
			}
			pos = str1.Find(",",0);
			row++;
		}
		UpdateData(FALSE);
		free(wkbuf);
		free(wkinbuf);
	}
	if ( scard[1] )
	{
		pos = 1;
		row = 1;
		m_grid2.SetRow(0);
		m_grid2.SetColWidth(0,600);
		// Show the Channels title on the Grid
		for(int i = 0 ; i < 5 ; i ++)
		{
			m_grid2.SetCol(i+1);
			m_grid2.SetColWidth(i+1,1500);
			str1.Format("CH%d(%s)", i+1, "4WR");
			m_grid2.SetCellAlignment(4);
			m_grid2.SetText(str1);
		}
		// Fetch the scanned readings
		wkbuf = (char *)malloc( 20 );
		if( !wkbuf )
		{
			MessageBox("Insufficient memory available.", "scancrds", MB_OK);
			return;
		}
		wkinbuf = (char *)malloc( 321 );
		if( !wkinbuf )
		{
			MessageBox("Insufficient memory available.", "scancrds", MB_OK);
			return;
		}
		strcpy(wkbuf, "fetch?\n");
		status = viWrite(instr2, (unsigned char *)wkbuf, 7, &retCount);
		Sleep(200);
		ZeroMemory(wkinbuf, 320);
		status = viRead(instr2, (unsigned char *)wkinbuf, 320, &retCount);
		str1.Format("%s,",wkinbuf);
		// Show the readings on the Grid
		while(pos > 0)
		{
			m_grid2.SetRow(row);
			m_grid2.SetCol(0);
			str2.Format("%d",row);
			m_grid2.SetText(str2);
			for(i = 0 ; i < 5; i ++)
			{	
				pos = str1.Find(",",0);
				if(pos < 1) 
					break;
				if(str1.Left(pos) == "+9.90000000E+37" || str1.Left(pos) == "+9.9E37\n")
					str2 = "OVLD";
				else
					str2.Format("%.6f",atof(str1.Left(pos)));
				m_grid2.SetCol(i+1);
				m_grid2.SetText(str2);
				str1 = str1.Mid(pos+1);
			}
			pos = str1.Find(",",0);
			row++;
		}
		UpdateData(FALSE);
		free(wkbuf);
		free(wkinbuf);
	}

}
